<script setup lang="ts">
const props = defineProps<{ gene: string }>();
const { fetchByGene } = usePublicationService();
const { data, error, pending } = await useAsyncData(
  `publications-${props.gene}`,
  () => fetchByGene(props.gene),
);
const repository = usePublicationRepository(props.gene, data.value || []);
</script>

<template>
  <AsyncView
    :error="error"
    :loading="pending"
    :error-message="`Failed to fetch publications for gene ${props.gene}`"
  >
    <CRUDView :repository="repository">
      <template #item="{ item }">
        <PublicationItem :publication="item" />
      </template>

      <template #inputs="{ item, update }">
        <PublicationInput :publication="item" @update:publication="update" />
      </template>
    </CRUDView>
  </AsyncView>
</template>
